Description
MicroService is the Schema for the microservices API
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

MicroServiceSpec defines the desired state of MicroService

statusobject

MicroServiceStatus defines the observed state of MicroService

.spec

Description
MicroServiceSpec defines the desired state of MicroService
Type
object
PropertyTypeDescription
accessLoggingobject

Access-log configuration.

authobject

Authentication information.

clustersarray

Cluster information.

configMapsarray

Configuration.

daemonsetsarray

Daemonset.

deploymentsarray

Deployment.

otelJavaAgentobject

OpenTelemetry Java agent configuration.

secretsarray

Secret.

servicesarray

Kubernetes Service information.

sidecarobject
statefulsetsarray

Statefulset.

swaggerobject

Swagger information.

.spec.accessLogging

Description
Access-log configuration.
Type
object
Required
enabled
PropertyTypeDescription
enabledboolean

.spec.auth

Description
Authentication information.
Type
object
PropertyTypeDescription
enabledboolean

.spec.clusters

Description
Cluster information.
Type
array

.spec.clusters[]

Type
object
Required
namesidecarInject
PropertyTypeDescription
namestring
sidecarInjectstring

.spec.configMaps

Description
Configuration.
Type
array

.spec.configMaps[]

Type
object
Required
name
PropertyTypeDescription
namestring

.spec.daemonsets

Description
Daemonset.
Type
array

.spec.daemonsets[]

Type
object
Required
name
PropertyTypeDescription
containerImagearray

Container image.

namestring

Deployment name.

otelJavaAgentImagestring

OpenTelemetry java agent image. Deprecated: OtelJavaAgentImage

sidecarEnabledboolean

Whether to add sidecar.

versionstring

Deployment version。

.spec.daemonsets[].containerImage

Description
Container image.
Type
array

.spec.daemonsets[].containerImage[]

Type
string

.spec.deployments

Description
Deployment.
Type
array

.spec.deployments[]

Type
object
Required
name
PropertyTypeDescription
containerImagearray

Container image.

namestring

Deployment name.

otelJavaAgentImagestring

OpenTelemetry java agent image. Deprecated: OtelJavaAgentImage

sidecarEnabledboolean

Whether to add sidecar.

versionstring

Deployment version。

.spec.deployments[].containerImage

Description
Container image.
Type
array

.spec.deployments[].containerImage[]

Type
string

.spec.otelJavaAgent

Description
OpenTelemetry Java agent configuration.
Type
object
PropertyTypeDescription
agentFileNamestring

The file name of agent.

enabledboolean

Whether to add Otel Java Agent.

mountPathstring

The mount path of the agent.

repositorystring

Image repository address of agent.

versionstring

Agent version.

.spec.secrets

Description
Secret.
Type
array

.spec.secrets[]

Type
object
Required
name
PropertyTypeDescription
namestring

.spec.services

Description
Kubernetes Service information.
Type
array

.spec.services[]

Type
object
Required
iscreatebysystemname
PropertyTypeDescription
iscreatebysystemboolean

Whether created by the system.

namestring

Kubernetes Service name.

.spec.sidecar

Type
object
PropertyTypeDescription
excludeInboundPortsstring
excludeOutboundIPRangesstring
excludeOutboundPortsstring

.spec.statefulsets

Description
Statefulset.
Type
array

.spec.statefulsets[]

Type
object
Required
name
PropertyTypeDescription
containerImagearray

Container image.

namestring

Deployment name.

otelJavaAgentImagestring

OpenTelemetry java agent image. Deprecated: OtelJavaAgentImage

sidecarEnabledboolean

Whether to add sidecar.

versionstring

Deployment version。

.spec.statefulsets[].containerImage

Description
Container image.
Type
array

.spec.statefulsets[].containerImage[]

Type
string

.spec.swagger

Description
Swagger information.
Type
object
PropertyTypeDescription
opIdstring
portinteger
urlstring

.status

Description
MicroServiceStatus defines the observed state of MicroService
Type
object
PropertyTypeDescription
availableReplicasinteger
canHotUpgradeboolean

Indicates whether the hot upgrade is enabled.

containsTcpboolean

Is there any TCP service within?

deployStatusstring
phasestring
replicasinteger
sidecarobject

SidecarStatus

sidecarHotUpgradeobject
validatingStatusobject

otel status

.status.sidecar

Description
SidecarStatus
Type
object
PropertyTypeDescription
conditionsarray
reasonstring
revisionobject
statestring

.status.sidecar.conditions

Type
array

.status.sidecar.conditions[]

Description
Condition contains details for one aspect of the current state of this API Resource. --- This struct is intended for direct use as an array at the field path .status.conditions. For example, type FooStatus struct{ // Represents the observations of a foo's current state. // Known .status.conditions.type are: "Available", "Progressing", and "Degraded" // +patchMergeKey=type // +patchStrategy=merge // +listType=map // +listMapKey=type Conditions []metav1.Condition `json:"conditions,omitempty" patchStrategy:"merge" patchMergeKey:"type" protobuf:"bytes,1,rep,name=conditions"` // other fields }
Type
object
Required
lastTransitionTimemessagereasonstatustype
PropertyTypeDescription
lastTransitionTimestring

lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

messagestring

message is a human readable message indicating details about the transition. This may be an empty string.

observedGenerationinteger

observedGeneration represents the .metadata.generation that the condition was set based upon. For instance, if .metadata.generation is currently 12, but the .status.conditions[x].observedGeneration is 9, the condition is out of date with respect to the current state of the instance.

reasonstring

reason contains a programmatic identifier indicating the reason for the condition's last transition. Producers of specific condition types may define expected values and meanings for this field, and whether the values are considered a guaranteed API. The value should be a CamelCase string. This field may not be empty.

statusstring

status of the condition, one of True, False, Unknown.

typestring

type of condition in CamelCase or in foo.example.com/CamelCase. --- Many .condition.type values are consistent across resources like Available, but because arbitrary conditions can be useful (see .node.status.conditions), the ability to deconflict is important. The regex it matches is (dns1123SubdomainFmt/)?(qualifiedNameFmt)

.status.sidecar.revision

Type
object
Required
currenttarget
PropertyTypeDescription
currentstring
targetstring

.status.sidecarHotUpgrade

Type
object
PropertyTypeDescription
statusobject

Mirror of actual sidecar hot upgrade status.

versionobject
versionsarray

.status.sidecarHotUpgrade.status

Description
Mirror of actual sidecar hot upgrade status.
Type
object
PropertyTypeDescription
observedRefobject
progressobject

HotUpgradeProgress

reasonstring
statestring

.status.sidecarHotUpgrade.status.observedRef

Type
object
PropertyTypeDescription
generationinteger
uidstring

UID is a type that holds unique ID values, including UUIDs. Because we don't ONLY use UUIDs, this is an alias to string. Being a type captures intent and helps make sure that UIDs and names do not get conflated.

.status.sidecarHotUpgrade.status.progress

Description
HotUpgradeProgress
Type
object
PropertyTypeDescription
failedinteger
podsarray
successinteger
totalinteger

.status.sidecarHotUpgrade.status.progress.pods

Type
array

.status.sidecarHotUpgrade.status.progress.pods[]

Type
object
Required
nametarget
PropertyTypeDescription
messagestring
namestring
planUIDstring

UID is a type that holds unique ID values, including UUIDs. Because we don't ONLY use UUIDs, this is an alias to string. Being a type captures intent and helps make sure that UIDs and names do not get conflated.

statestring
targetstring

.status.sidecarHotUpgrade.version

Type
object
Required
currenttarget
PropertyTypeDescription
currentstring
targetstring

.status.sidecarHotUpgrade.versions

Type
array

.status.sidecarHotUpgrade.versions[]

Type
object
Required
currentnametarget
PropertyTypeDescription
currentstring
namestring
targetstring

.status.validatingStatus

Description
otel status
Type
object
PropertyTypeDescription
invalidboolean
messagearray

.status.validatingStatus.message

Type
array

.status.validatingStatus.message[]

Type
string

API Endpoints

The following API endpoints are available:

  • /apis/asm.alauda.io/v1beta3/namespaces/{namespace}/microservices
    • DELETE: delete collection of MicroService
    • GET: list objects of kind MicroService
    • POST: create a new MicroService
  • /apis/asm.alauda.io/v1beta3/namespaces/{namespace}/microservices/{name}
    • DELETE: delete the specified MicroService
    • GET: read the specified MicroService
    • PATCH: partially update the specified MicroService
    • PUT: replace the specified MicroService
  • /apis/asm.alauda.io/v1beta3/namespaces/{namespace}/microservices/{name}/status
    • GET: read status of the specified MicroService
    • PATCH: partially update status of the specified MicroService
    • PUT: replace status of the specified MicroService

/apis/asm.alauda.io/v1beta3/namespaces/{namespace}/microservices

HTTP method
DELETE
Description
delete collection of MicroService
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind MicroService
HTTP responses
HTTP codeResponse body
200 - OKMicroServiceList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new MicroService
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyMicroService schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKMicroService schema
201 - CreatedMicroService schema
202 - AcceptedMicroService schema
401 - UnauthorizedEmpty

/apis/asm.alauda.io/v1beta3/namespaces/{namespace}/microservices/{name}

HTTP method
DELETE
Description
delete the specified MicroService
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified MicroService
HTTP responses
HTTP codeResponse body
200 - OKMicroService schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified MicroService
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKMicroService schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified MicroService
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyMicroService schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKMicroService schema
201 - CreatedMicroService schema
401 - UnauthorizedEmpty

/apis/asm.alauda.io/v1beta3/namespaces/{namespace}/microservices/{name}/status

HTTP method
GET
Description
read status of the specified MicroService
HTTP responses
HTTP codeResponse body
200 - OKMicroService schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified MicroService
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKMicroService schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified MicroService
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyMicroService schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKMicroService schema
201 - CreatedMicroService schema
401 - UnauthorizedEmpty